#!/bin/sh

clang-tidy \
library/src/sfizz/ADSREnvelope.cpp \
library/src/sfizz/Curve.cpp \
library/src/sfizz/Effects.cpp \
library/src/sfizz/EQPool.cpp \
library/src/sfizz/FilePool.cpp \
library/src/sfizz/FilterPool.cpp \
library/src/sfizz/MidiState.cpp \
library/src/sfizz/Opcode.cpp \
library/src/sfizz/Oversampler.cpp \
library/src/sfizz/Panning.cpp \
library/src/sfizz/sfizz.cpp \
library/src/sfizz/Region.cpp \
library/src/sfizz/RegionStateful.cpp \
library/src/sfizz/SIMDHelpers.cpp \
library/src/sfizz/simd/HelpersSSE.cpp \
library/src/sfizz/simd/HelpersAVX.cpp \
library/src/sfizz/Synth.cpp \
library/src/sfizz/Voice.cpp \
library/src/sfizz/effects/Eq.cpp \
library/src/sfizz/effects/Filter.cpp \
library/src/sfizz/effects/Lofi.cpp \
library/src/sfizz/effects/Nothing.cpp \
plugins/vst/SfizzVstController.cpp \
plugins/vst/SfizzVstProcessor.cpp \
plugins/vst/SfizzVstEditor.cpp \
plugins/vst/SfizzVstState.cpp \
-- \
-Ilibrary/external/abseil-cpp \
-Ilibrary/external/jsl/include \
-Ilibrary/external/filesystem/include \
-Ilibrary/external/atomic_queue/include \
-Ilibrary/external/threadpool \
-Ilibrary/src/external/hiir \
-Ilibrary/src/external/pugixml/src \
-Ilibrary/external/st_audiofile/src \
-Ilibrary/external/st_audiofile/thirdparty/dr_libs \
-Ilibrary/src/sfizz \
-Ilibrary/src \
-Ilibrary/src/sfizz/utility/bit_array \
-Ilibrary/src/sfizz/utility/spin_mutex \
-Ilibrary/src/external/spline \
-Ilibrary/src/external/cpuid/src \
-Ilibrary/external/simde \
-Iplugins/common \
-Iplugins/vst \
-Iplugins/vst/external/VST_SDK/VST3_SDK \
-Iplugins/editor/external/vstgui4 \
-Iplugins/vst/external/ring_buffer \
-Iplugins/editor/src \
-DNDEBUG -std=c++17
